<template>
  <div class="wrapper">
    <!-- breadcrumb -->
    <el-row>
      <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
        <div class>
          <el-breadcrumb class="breadcrumb nopadding" separator="/">
            <el-breadcrumb-item
              v-for="crumb in breadcrumbs"
              :key="crumb"
              :to="{ path: '/' }"
              :class="breadcrumb-item"
            >{{ crumb.toUpperCase() }}</el-breadcrumb-item>
            <el-breadcrumb-item>
              {{
              itemName.toUpperCase()
              }}
            </el-breadcrumb-item>
          </el-breadcrumb>
        </div>
      </el-col>
    </el-row>

    <!-- main body -->
    <el-row :gutter="10">
      <!-- carousel -->
      <el-col :xs="24" :sm="24" :md="14" :lg="14" :xl="14">
        <div>
          <el-carousel indicator-position="outside" height="660px">
            <el-carousel-item v-for="(carousel, index) in activeProduct.media" :key="index">
              <el-image :src="bindImageUrl(carousel.url)" fit="contain"></el-image>
            </el-carousel-item>
          </el-carousel>
        </div>
      </el-col>

      <!-- details -->
      <el-col :xs="24" :sm="24" :md="8" :lg="8" :xl="8">
        <div class="details-wrapper">
          <div class="title">
            <h1 class="product-name">{{ itemName }}</h1>
          </div>

          <!-- Price -->
          <div class="price">
            <span class="sales">
              <span class="value">${{ activeProduct.price }}</span>
            </span>
            <div class="price-desc">
              <div class="product-afterpay-message pdp-afterpay-message">
                <span class="afterpay-link" title="terms.conditions.label">
                  <span class="afterpay-label">of 4 payments of US$16.24 with</span>
                  <img
                    class="afterpay-image"
                    src="https://www.showpo.com/on/demandware.static/-/Library-Sites-ShowpoSharedLibrary/default/dwe8f9874a/images/afterpay/afterpay-logo-updated.png"
                    alt="Afterpay"
                  />
                  <a class="afterpay-more-info">More Info</a>
                </span>
              </div>
            </div>
          </div>

          <!-- Color Attributes -->
          <el-row class="attribute">
            <el-col :span="24" class="nopadding">
              <div class="attribute-color">
                <!-- Select <Attribute> Label -->
                <span class="color non-input-label">Color :</span>
                <span class="selected-color">{{ activeProduct.pdpColor }}</span>
              </div>
            </el-col>
            <el-col :span="24" class="nopadding">
              <div class="attribute-model">
                <!-- Select <Attribute> Label -->
                <a
                  v-for="(prd, model) in products"
                  :class="{ active: model === activeModel}"
                  @click="selectModel(model)"
                >
                  <el-image
                    :src="bindImageUrl(prd.media[0].url)"
                    fit="contain"
                    @click="setActiveProduct(prd)"
                  ></el-image>
                </a>
              </div>
            </el-col>
          </el-row>

          <!-- Sizes -->
          <el-row>
            <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
              <div class="select-size-wrapper">
                <div class="size-details">
                  <span>SELECT US SIZE:</span>
                  <span>{{ selectedSize }}</span>
                  <span class="fr">
                    <a href="#">Size Guide</a>
                  </span>
                </div>
                <ul class="size-list nopadding">
                  <li
                    v-for="(item, index) in activeProduct.children"
                    :key="index"
                    :class="{
                      active: index === activeItem,
                      outStock: !item.inStock
                    }"
                    @click="setSize(item), selectItem(index)"
                  >
                    <p>{{ item.attributes.size.split(" ")[0] }}</p>
                    <p>{{ item.attributes.size.split(" ")[1] }}</p>
                  </li>
                </ul>
              </div>
            </el-col>
          </el-row>

          <!-- Add To Cart -->
          <el-row class="cart">
            <el-col :span="18">
              <div>
                <button
                  class="add-to-cart"
                  data-toggle="modal"
                  data-target="#chooseBonusProductModal"
                  data-pid="eyes-that-know-me-dress-in-black"
                >Add to bag</button>
              </div>
            </el-col>
            <el-col :span="6">
              <div class="favorite">
                <a href="#">
                  <i class="el-icon-collection-tag"></i>
                </a>
              </div>
            </el-col>
          </el-row>

          <!-- Main Description -->
          <el-row>
            <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
              <div>
                <el-collapse v-model="activeNames" @change="handleChange">
                  <!-- collapse DESCRIPTION -->
                  <el-collapse-item title="DESCRIPTION" name="1">
                    <vue-markdown html :source="activeProduct.long_description"></vue-markdown>
                  </el-collapse-item>
                  <!-- collapse SHIPPING & RETURNS -->
                  <el-collapse-item title="FAST SHIPPING & EASY RETURNS" name="2">
                    <div>
                      <p>
                        Showpo offers a flat-rate of $9.95 for all orders or
                        free standard shipping for orders over $50.
                      </p>

                      <p>
                        Head over to our
                        <a
                          href="https://www.showpo.com/us/shipping-info/"
                          title="Go to Shipping information"
                          style="color: #0000EE;"
                        >shipping page</a>
                        for more info.
                      </p>

                      <p>
                        If for any reason you aren’t happy with your order, you
                        can return the items for store credit.
                      </p>

                      <p></p>
                      <li>
                        You have 14 days to post your return back to us,
                        starting from the day you receive your order. Exceptions
                        apply.
                      </li>
                      <li>
                        To exchange an item, we recommend returning your items
                        back to us, then using your store credit to place a new
                        order. Exceptions apply.
                      </li>
                    </div>
                  </el-collapse-item>
                </el-collapse>
              </div>
            </el-col>
          </el-row>
        </div>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import VueMarkdown from "vue-markdown";
import { getData } from "../api/get";

export default {
  name: "products",
  components: { VueMarkdown },
  data() {
    return {
      activeProduct: {},
      activeNames: ["1"],
      breadcrumbs: [],
      products: [],
      selectedSize: "",
      handleChange: 1,
      breadcrumb: "",
      item: 0,
      activeItem: null,
      activeModel: 0,
    };
  },
  computed: {
    itemName() {
      return this.activeProduct.name ? this.activeProduct.name : "";
    },
    urlId() {
      return this.$route.params.urlId;
    },
  },
  watch: {
    urlId(val) {
      const selectedProduct = this.setActiveProduct.find(
        (item) => item.url === val
      );
      console.log(selectedProducts);
    },
  },
  async beforeCreate() {
    const data = await getData();
    this.breadcrumbs = data.product.hierarchy.replace(/\s/g, "").split(">");
    this.products = data.product.children;
    const urlId = this.$route.params.urlId;
    this.setActiveProduct(data.product.children[0]);
  },
  methods: {
    bindImageUrl(url) {
      const baseUrl = `https://www.showpo.com`;
      return baseUrl + url;
    },
    setActiveProduct(item) {
      this.setSize("");
      this.activeProduct = item;
      this.class = "";
    },
    setSize(val) {
      try {
        this.selectedSize = val.attributes.size.split(" ")[0];
      } catch (e) {
        this.selectedSize = "";
      }
    },
    selectItem(index) {
      this.activeItem = index;
    },
    selectModel(model) {
      this.activeModel = model;
    },
  },
};
</script>

<style scoped>
.el-breadcrumb__item {
  font-size: 0.8em;
}
</style>
